<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;
use SM\Util\Procedure\FctRefMvCcustoContrato;

class CentroCustoRelatorioFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCentroCustoRelatorio()
    {
        $sql = "SELECT
                    RELATORIO.NRSEQCONTRATO,
                    RELATORIO.NRSEQMODCONTRA,
                    RELATORIO.NMMODCONTRATO,
                    RELATORIO.CDOPERRESPONSAVEL,
                    RELATORIO.NMOPERADOR,
                    RELATORIO.NRCONTRATOFCT,
                    RELATORIO.DTAPROVACAO,
                    RELATORIO.NRSEQORCAMENTO,
                    RELATORIO.NRORCAMENTOMODELO,
                    RELATORIO.NMORCAMENTOMODELO,
                    RELATORIO.NRORCAMENTO,
                    RELATORIO.DTACEITEORCA,
                    RELATORIO.NRTIPOORCAMENTO,
                    RELATORIO.NMTIPOORCAMENTO,
                    RELATORIO.IDTPFATURA,
                    RELATORIO.DSTPFATURA,
                    RELATORIO.IDSITUACAOCONTRATO,
                    RELATORIO.NRPARCNEGOCIO,
                    RELATORIO.NMPRINCIPALPARC,
                    RELATORIO.NMSECUNDARIPARC,
                    RELATORIO.NRINSCRICAOPARC,
                    RELATORIO.NMITEMCONTRATO,
                    RELATORIO.CDSERVORCA,
                    RELATORIO.NMSERVORCA,
                    RELATORIO.IDELEMENTO,
                    RELATORIO.CDCENTCUST,
                    RELATORIO.NMCENTCUST,
                    RELATORIO.QTMEDIDAITEMCONT,
                    RELATORIO.QTMEDIDAVARIAVEL,
                    RELATORIO.CDTPMEDIDAVARIAVEL,
                    RELATORIO.DSTPMEDIDAVARIAVEL,
                    RELATORIO.VRTOTSERVORCA,
                    RELATORIO.VRTOTAL_ACR_DESC,
                    RELATORIO.IDDELPHI,
                    RELATORIO.DTINICOMPET,
                    RELATORIO.DTFINCOMPET,
                    RELATORIO.QTMEDIDAMEDICAO,
                    RELATORIO.VRITEMCONTCOMDESC,
                    RELATORIO.NRORG,
                    CONTRATO.IDATIVO
                FROM
                    FCT_MV_CCUSTO_CONTRATO RELATORIO
                INNER JOIN FCT_CONTRATO CONTRATO ON RELATORIO.NRSEQCONTRATO = CONTRATO.NRSEQCONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDataUltimaAtualizacaoRelatorioCentroCusto()
    {
        $sql = "SELECT TO_CHAR(DTULTATUMVCCUSTOCONT, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATUMVCCUSTOCONT FROM fct_parametrogeral";
        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function atualizarView()
    {
        $procedure = new FctRefMvCcustoContrato($this->connection);
        $procedure->executar();
    }
}
